VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VB to DPLOT Interface Example"
   ClientHeight    =   5955
   ClientLeft      =   2190
   ClientTop       =   2700
   ClientWidth     =   4995
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "VBDPLOT.frx":0000
   LinkTopic       =   "Form1"
   NegotiateMenus  =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5955
   ScaleWidth      =   4995
   Begin VB.CheckBox Check1 
      Caption         =   "Use DPlot Jr"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1815
   End
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   1920
      TabIndex        =   14
      Text            =   "1000"
      Top             =   4860
      Width           =   1095
   End
   Begin VB.CommandButton Plot3D 
      Caption         =   "Plot"
      Height          =   495
      Left            =   3360
      TabIndex        =   15
      Top             =   4800
      Width           =   855
   End
   Begin VB.OptionButton Option2 
      Caption         =   "X&YXY() cmd"
      Height          =   255
      Left            =   2880
      TabIndex        =   10
      Top             =   3480
      Width           =   1575
   End
   Begin VB.OptionButton Option1 
      Caption         =   "&XY() command"
      Height          =   255
      Left            =   2880
      TabIndex        =   9
      Top             =   3120
      Value           =   -1  'True
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Caption         =   "Method"
      Height          =   975
      Left            =   2760
      TabIndex        =   8
      Top             =   2880
      Width           =   1815
   End
   Begin VB.CommandButton UpdateButton 
      BackColor       =   &H80000005&
      Caption         =   "&Update"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2760
      TabIndex        =   4
      Top             =   1560
      Width           =   1335
   End
   Begin VB.Timer Timer1 
      Left            =   3720
      Top             =   840
   End
   Begin VB.CommandButton RealTimeButton 
      BackColor       =   &H80000005&
      Caption         =   "&Real Time Simulation"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   2535
   End
   Begin VB.TextBox Text1 
      Height          =   405
      Left            =   120
      TabIndex        =   3
      Top             =   1560
      Width           =   2535
   End
   Begin VB.CommandButton PTHistoryButton 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "&Generate P-T History"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   3000
      Width           =   2535
   End
   Begin VB.Label Label8 
      Height          =   255
      Left            =   240
      TabIndex        =   16
      Top             =   5400
      Width           =   3255
   End
   Begin VB.Label Label7 
      Alignment       =   1  'Right Justify
      Caption         =   "Number of points:"
      Height          =   255
      Left            =   120
      TabIndex        =   13
      Top             =   4920
      Width           =   1695
   End
   Begin VB.Label Label6 
      Caption         =   "Plot random points fitting Z=sin(x)*cos(y) for X,Y = +/- PI"
      Height          =   375
      Left            =   240
      TabIndex        =   12
      Top             =   4320
      Width           =   4095
   End
   Begin VB.Line Line3 
      X1              =   240
      X2              =   4800
      Y1              =   4200
      Y2              =   4200
   End
   Begin VB.Line Line2 
      X1              =   0
      X2              =   4800
      Y1              =   600
      Y2              =   600
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   4800
      Y1              =   2640
      Y2              =   2640
   End
   Begin VB.Label Label4 
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   3720
      Width           =   2535
   End
   Begin VB.Label Label3 
      Height          =   255
      Left            =   840
      TabIndex        =   7
      Top             =   2160
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Time:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   2160
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "&Plot Window:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetTickCount Lib "kernel32" () As Long
Dim sExec As String

Private Sub Form_Load()
    Dim ret As Integer
'   Set timer interval to 1/2 second
    Timer1.Interval = 500
    Timer1.Enabled = False
    Text1.Visible = False
    Label1.Visible = False
    Label2.Visible = False
    Label3.Visible = False
    Option1.Value = True
'   Set form position to upper-left corner of screen
    ret = SetWindowPos(Me.hwnd, 0, 0, 0, 0, 0, SWP_NOSIZE)
End Sub

Private Sub Plot3D_Click()
'
'   This demo uses the XYZEx command to send random 3D points to DPlot, which
'   will then generate a contour plot. For a description of DPLOT commands,
'   view the DPLOT Help file, select the "Search" button, and select
'   "command syntax"
'
    Dim i As Long
    Dim x As Single
    Dim y As Single
    Dim z As Single
    Dim N As Long
    Dim Nbuff As Long
    Dim t1 As Long
    Dim t2 As Long
    Dim Buff As String
'
'   The maximum command string length that DPlot will interpret is
'   32768 characters, including all delimiters and the command name
'   itself. MAX_POINTS is the maximum number of points this app will
'   send in any one XYZEx command. That's probably a bit conservative
'   and you can most likely get away with more... but this will definitely
'   work and gets around a problem with checking string length rather
'   than number of points: we don't have to re-write the number of
'   points at the start of the command string.
'
'   Excel users note: You can't expect this to work from an Excel VBA
'   function. The maximum string length used with DDEExecute in Excel
'   seems to be 256 characters, so MAX_POINTS will necessarily be much
'   smaller in a VBA function.
'
    Const MAX_POINTS = 1000
    Const PI = 3.14159265358979
    
    Call StartDPLOT(Me, Check1.Value)
'
    t1 = GetTickCount()
    N = Val(Text2.Text)
    
    Text1.LinkMode = 0
    Text1.LinkTopic = "DPLOT|System"
    Text1.LinkMode = 2
    Text1.LinkTimeout = 100
    Text1.LinkExecute "[AppRestore()][FileNew(3)]"

'   Delay redrawing until we're done:
    Text1.LinkExecute "[PostponeRedraw()]"

'   Generate and send data
    Text1 = ""
    
    If N > MAX_POINTS Then
      Buff = Str$(MAX_POINTS) + ","
    Else
      Buff = Str$(N) + ","
    End If
    Nbuff = 0       ' Number of accumulated points
    For i = 1 To N
        x = -PI + 2 * PI * Rnd
        y = -PI + 2 * PI * Rnd
        z = Sin(x) * Cos(y)
        Buff = Buff + Str$(x) + "," + Str$(y) + "," + Str$(z) + ","
        Nbuff = Nbuff + 1
        If Nbuff = MAX_POINTS Then
          Text1.LinkExecute "[XYZEx(0," + Buff + ")]"
          Nbuff = 0
          If N - i > MAX_POINTS Then
            Buff = Str$(MAX_POINTS) + ","
          Else
            Buff = Str$(N - i) + ","
          End If
        End If
    Next i
    ' If any points have been generated but not transmitted, send 'em now
    ' and tell DPlot to triangulate/plot. Otherwise, instruct DPlot to
    ' triangulate/plot with a XYZRegen.
    If Nbuff > 0 Then
        Text1.LinkExecute "[XYZEx(1," + Buff + ")]"
    Else
        Text1.LinkExecute "[XYZRegen()]"
    End If
    Text1 = ""
    Buff = ""

    Text1.LinkExecute "[ContourMethod(0)][ContourLevels(20,-1,1)][ContourLegend(1)]"
'   Set title of plot
    Text1.LinkExecute "[Title1(" + Chr$(34) + "Data from Visual Basic App" + Chr$(34) + ")]"
    Text1.LinkExecute "[Caption(" + Chr$(34) + "Visual Basic Demo Contour Plot" + Chr$(34) + ")]"
'   Force a re-draw to show what we've done, and clear the edit flag so that
'   DPlot won't annoy us with a prompt to save changes (unless user
'   subsequently changes something)
    Text1.LinkExecute "[ViewRedraw()][ClearEditFlag()]"
    Text1.LinkMode = 0
    t2 = GetTickCount()
    Label8.Caption = "Elapsed Time: " + Str$(t2 - t1) + " msec"
    Exit Sub
End Sub

Private Sub PTHistoryButton_Click()
'
'   This demo uses one of two methods for sending data generated by
'   this application to DPLOT for Windows. For a description of
'   DPLOT commands, view the DPLOT Help file, select the "Search"
'   button, and select "command syntax"
'
    Dim i As Long
    Dim N As Long
    Dim Nbuff As Long
    Dim t1 As Long
    Dim t2 As Long
    Dim Decay As Single
    Dim dT As Single
    Dim Noise As Single
    Dim P As Single
    Dim Pso As Single
    Dim StartTime As Single
    Dim StopTime As Single
    Dim t As Single
    Dim Ta As Single
    Dim Td As Single
    Dim Tn As Single
    Dim Buff As String
    Const MAX_XYXY = 200       ' Used for Option2
    
    Call StartDPLOT(Me, Check1.Value)
'
'   Decay      = Decay coefficient of modified Friedlander eqn.
'   dT         = Time step
'   N          = Total number of values to plot
'   P          = Pressure
'   Pso        = Peak incident overpressure
'   StartTime  = 1st time value to plot
'   StopTime   = last time value to plot
'   T          = Time
'   Ta         = Arrival time
'   Td         = Duration
'   Tn         = Normalized time
'   Noise      = Stuff added to signal to make it look real,
'                possibly fooling sponsors into believing
'                we actually conducted field tests
'
    t1 = GetTickCount()
    StartTime = 0!
    StopTime = 50!
    Ta = 5! * Rnd
    Td = 40! * Rnd
    Pso = 100! * Rnd
    Decay = 8! * Rnd
    dT = 0.05
    N = (StopTime - StartTime) / dT + 1

    Text1.LinkMode = 0
    Text1.LinkTopic = "DPLOT|System"
    Text1.LinkMode = 2
    Text1.LinkTimeout = 100
    Text1.LinkExecute "[AppRestore()][FileNew()][FileArrays(2," + Str$(N) + ")]"
    Text1.LinkExecute "[AutoSize()][AutoScale()]"

'   Delay redrawing until we're done. This isn't strictly necessary but
'   avoids unnecessary screen redraws and speeds things up a bit.
    Text1.LinkExecute "[PostponeRedraw()]"

'   Generate and send data
'
'   Notes on methods for transferring data:
'
'   The [XY()] LinkExecute (Option1) is the most straightforward, but is slow
'   on some systems since the data is transferred one point at a time. Note that
'   this is not always the case, however. On a Windows 2000 system this command
'   is comparable to Option2, while on Windows 95 and 98 it is noticeably sluggish.
'
'   Option2 will always be faster than Option1 and for more than 1000 or so
'   data points should be considerably faster. NOTE: The maximum command
'   string length sent to DPlot is 32768 characters, including delimiters and
'   spaces. So if each X,Y pair requires an average of 16 characters, that means
'   we can't send more than 2000 or so pairs in one transaction. We get around
'   this limit by sending (at most) MAX_XYXY (set to 1000 above) pairs at a time.
'
    Text1 = ""
    
    If Option2.Value = True Then
        If N > MAX_XYXY Then
            Buff = Str$(MAX_XYXY) + ","
        Else
            Buff = Str$(N) + ","
        End If
    End If
    Nbuff = 0
    For i = 1 To N
        t = dT * (i - 1)
        Noise = Pso / 10# * (0.5 - Rnd)
        If t < Ta Then
            P = Noise
        ElseIf t < Ta + Td Then
            Tn = (t - Ta) / Td
            P = Pso * (1# - Tn) * Exp(-Decay * Tn) + Noise
        Else
            P = Noise
        End If
        If Option1.Value = True Then
            Text1.LinkExecute "[XY(" + Str$(t) + "," + Str$(P) + ")]"
        ElseIf Option2.Value = True Then
            Buff = Buff + Str$(t) + "," + Str$(P) + ","
            Nbuff = Nbuff + 1
            If Nbuff = MAX_XYXY Then
                Text1.LinkExecute "[XYXY(" + Buff + ")]"
                Nbuff = 0
                If N - i > MAX_XYXY Then
                    Buff = Str$(MAX_XYXY) + ","
                Else
                    Buff = Str$(N - i) + ","
                End If
            End If
        End If
    Next i
    If Option2.Value = True Then
        If Nbuff > 0 Then
            Text1.LinkExecute "[XYXY(" + Buff + ")]"
        End If
    End If
    Text1 = ""
    Buff = ""

'   Turn on data processing mode (pressure) to perform automatic integration
'   (but not if DPlot Jr is used, since it doesn't support data processing mode)
    If Check1.Value = 0 Then
        Text1.LinkExecute "[DataProcess(1," + Chr$(34) + "P" + Chr$(34) + ",0)]"
    End If

'   Set title of plot
    Text1.LinkExecute "[Title1(" + Chr$(34) + "Data from Visual Basic App" + Chr$(34) + ")]"
'   Force a re-draw to show what we've done, and clear the edit flag so that
'   DPlot won't annoy us with a prompt to save changes (unless user
'   subsequently changes something)
    Text1.LinkExecute "[ViewRedraw()][ClearEditFlag()]"
    Text1.LinkExecute "[Caption(" + Chr$(34) + "VB P-T History" + Chr$(34) + ")]"
    Text1.LinkMode = 0
    t2 = GetTickCount()
    Label4.Caption = "Elapsed Time: " + Str$(t2 - t1) + " msec"
    Exit Sub
End Sub

Private Sub RealTimeButton_Click()
    Dim i As Long
    Dim N As Long
    Dim rc As RECT

'   If the timer is enabled, we're already running the simulation and user
'   clicked this button to stop the simulation:
    If Timer1.Enabled = True Then
        Text1.LinkExecute "[Enable(1)]"
        Text1.LinkExecute "[ViewRedraw()]"
        Text1.LinkMode = 0
        Exit Sub
    End If
    
    Call StartDPLOT(Me, Check1.Value)

'   Enable the timer and the "Update" button
    Timer1.Enabled = True
    UpdateButton.Enabled = True

'   Initiate DDE conversation with DPLOT
    Text1.LinkMode = 0
    Text1.LinkTopic = "DPLOT|System"
    Text1.LinkMode = 2
    Text1.LinkTimeout = 100

    On Error GoTo RealTimeError
    
'   Disable DPLOT menu commands. DPLOT disables itself during processing
'   of LinkExecute commands, but in some cases synchronization problems
'   still allow the user to crash DPLOT by opening a dialog box between
'   LinkExecute commands.
'   This example re-enables DPLOT when the user clicks on "Stop...",
'   (see above) but this shouldn't strictly be necessary, since
'   DPLOT will enable itself when the DDE conversation is terminated.
    Text1.LinkExecute "[Enable(0)]"
    
    sExec = "[FileNew()]"
    Text1.LinkExecute sExec
    
'   Instruct DPLOT to allocate space for 2 curves, 1 hour's
'   worth of data:
    N = 3600000 / Timer1.Interval
    sExec = "[FileArrays(2," + Str$(N) + ")]"
    Text1.LinkExecute sExec

'   Use thick (.03") lines to push DPLOT's performance limits
    sExec = "[LineWidth(1,30)]"
    sExec = sExec + "[LineWidth(2,30)]"
    sExec = sExec + "[LineType(1," + Str$(DU_LINE_SOLID) + ")]"
    sExec = sExec + "[LineType(2," + Str$(DU_LINE_SOLID) + ")]"
    sExec = sExec + "[Color(1,255,0,0)]"
    sExec = sExec + "[Color(2,0,0,255)]"
    Text1.LinkExecute sExec

'   Plotting window is initially 1 minute wide:
    Text1.Text = "0.,-1.5,60.,1.5"
    sExec = "[ManualScale(" & Text1.Text & ")][AutoSize()]"
    Text1.LinkExecute sExec

'   Set labels:
    sExec = "[XAxisLabel(" + Chr$(34) + "Time (seconds)" + Chr$(34) + ")]"
    sExec = sExec & "[LegendParams(0.5,10,1,1,.05,.05)]"
    sExec = sExec & "[Legend(1," + Chr$(34) + "SIN(t/4)" + Chr$(34) + ")]"
    sExec = sExec & "[Legend(2," + Chr$(34) + "COS(t/4)" + Chr$(34) + ")]"
    sExec = sExec & "[Title1(" + Chr$(34) + "RealTime Demo" + Chr$(34) + ")]"
    sExec = sExec & "[Caption(" + Chr$(34) + "Visual Basic Demo" + Chr$(34) + ")]"
    Text1.LinkExecute sExec
    On Error GoTo 0

'   Get start time from API function GetTickCount
    StartTicks& = GetTickCount()

'   Change button caption to indicate that clicking it
'   again stops the DDE conversation:
    RealTimeButton.Caption = "&Stop Simulation"
    Label1.Visible = True
    Label2.Visible = True
    Label3.Visible = True
    Text1.Visible = True
'
'   See Timer1_Timer procedure to see how data values are sent to DPLOT
'
    Exit Sub

RealTimeError:
    MsgBox "Cannot execute the command " & sExec, MB_OK Or MB_ICONEXCLAMATION
    Text1.LinkMode = 0
    Exit Sub

End Sub

Private Sub Text1_LinkClose()
    Timer1.Enabled = False
    UpdateButton.Enabled = False
    Text1.Visible = False
    Label1.Visible = False
    Label2.Visible = False
    Label3.Visible = False
    RealTimeButton.Caption = "&Real Time Simulation"
End Sub

Private Sub Timer1_Timer()
    Dim x As Single
    Dim y As Single
'   Use API function GetTickCount() to get actual time, since the timer can't
'   be relied on to post timer events at the interval we requested.
    x = CSng(GetTickCount() - StartTicks) / 1000#
    y = Sin(x / 4)
    On Error GoTo TimerError
    sExec = "[SelectCurve(1)][XY(" + Str$(x) + "," + Str$(y) + ")]"
    Text1.LinkExecute sExec
    y = Cos(x / 4)
    sExec = "[SelectCurve(2)][XY(" + Str$(x) + "," + Str$(y) + ")]"
    Text1.LinkExecute sExec
    On Error GoTo 0
    Label3.Caption = Str$(x)
    Exit Sub

TimerError:
    MsgBox "Cannot execute the command " & sExec, MB_OK Or MB_ICONEXCLAMATION
    Text1.LinkMode = 0
    Exit Sub

End Sub

Private Sub UpdateButton_Click()
    Text1.LinkExecute "[ManualScale(" + Text1.Text + ")]"
End Sub

