#define INCLUDE_DDEML_H
#define INCLUDE_SHELLAPI_H
#include <windows.h>
#include <math.h>
#include <stdio.h>
#include "dplot.h"

HWND StartDPLOT(int Jr)
{
	LONG	dwLength;
	HCURSOR	hCursor;
	HKEY	hKey;
	HWND	hwndDPLOT;
	int		Status;
	char	szDPLOTName[255];
	char	szName[16];
	char	szSubkey[32];

	strcpy(szName,"DPLOT");
	if(Jr)
		strcat(szName,"JR");

	hwndDPLOT = FindWindow( szName, NULL );
	
	if( !hwndDPLOT ) {
	/* DPlot is not currently running.  Check user's
		registration database for location.              */
		strcpy(szSubkey,"Software\\");
		strcat(szSubkey,szName);
		strcat(szSubkey,"\\shell\\open\\command");
		if( RegOpenKey(HKEY_CURRENT_USER,szSubkey,&hKey) == ERROR_SUCCESS )
		{
			dwLength = sizeof(szDPLOTName);
			RegQueryValue(hKey,(LPCSTR)NULL,(LPSTR)szDPLOTName,&dwLength);
			RegCloseKey(hKey);
		}
		else
		{
			strcpy(szDPLOTName,szName);
			strcat(szDPLOTName,".EXE");
		}
		
		hCursor = SetCursor(LoadCursor(0,IDC_WAIT));
		// Append /nonag commandline switch so that the demo will work
		// correctly with the evaluation version
		strcat(szDPLOTName," /nonag");
		Status = WinExec(szDPLOTName,SW_SHOWNOACTIVATE);
		SetCursor(hCursor);
		if(Status <= 31) return (HWND)NULL;
		hwndDPLOT = FindWindow( szName, NULL );
	}
	return hwndDPLOT;
}


extern HCONV hConvDPLOT;       // Conversation handle returned by DdeConnect

HDDEDATA CALLBACK DdeCallback( UINT uType,      // transaction type
							  UINT uFmt,       // clipboard data format
							  HCONV hconv,     // handle to the conversation
							  HSZ hsz1,        // handle to a string
							  HSZ hsz2,        // handle to a string
							  HDDEDATA hdata,  // handle to a global memory object
							  DWORD dwData1,   // transaction-specific data
							  DWORD dwData2  ) // transaction-specific data
{
	
	switch(uType) {
		
	case XTYP_XACT_COMPLETE:
	/* Note: This message is only received for asynchronous transactions,
	which this demo does not perform (and generally are not
		recommended) */
		switch LOWORD(dwData2) {
		case DDE_FBUSY:
			MessageBox(0,
				"DPlot is currently busy ... try again later.",
				"DPlot DDE",
				MB_OK | MB_ICONEXCLAMATION  );
			break;
		case DDE_FNOTPROCESSED:
			MessageBox(0,
				"Negative acknowledgement received from DPlot",
				"DPlot DDE",
				MB_OK | MB_ICONEXCLAMATION  );
			break;
		}
		
		case XTYP_DISCONNECT:
			hConvDPLOT = 0;
			break;
	}
	return 0;
}



