Attribute VB_Name = "GLOBAL"
Option Explicit
Global Const HKEY_CLASSES_ROOT = &H80000000
Global Const HKEY_CURRENT_USER = &H80000001
Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Declare Function BringWindowToTop Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Long
Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As Any, phkResult As Long) As Long
Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As Long, ByVal lpValue As Any, lpcbValue As Long) As Long
Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Global StartTicks&
Global iCancel

Global Const SWP_NOSIZE = 1
'
' Common dialog flags:
'
Global Const OFN_ALLOWMULTISELECT = &H200
Global Const OFN_CREATEPROMPT = &H2000
Global Const OFN_EXTENSIONDIFFERENT = &H400
Global Const OFN_FILEMUSTEXIST = &H1000
Global Const OFN_HIDEREADONLY = &H4
Global Const OFN_NOCHANGEDIR = &H8
Global Const OFN_NOREADONLYRETURN = &H8000
Global Const OFN_NOVALIDATE = &H100
Global Const OFN_OVERWRITEPROMPT = &H2
Global Const OFN_PATHMUSTEXIST = &H800
Global Const OFN_READONLY = &H1
Global Const OFN_SHAREAWARE = &H4000
Global Const OFN_SHOWHELP = &H10
'
' MsgBox types
'
Global Const MB_OK = 0
Global Const MB_OKCANCEL = 1
Global Const MB_ABORTRETRYIGNORE = 2
Global Const MB_YESNOCANCEL = 3
Global Const MB_RETRYCANCEL = 5
Global Const MB_ICONSTOP = 16
Global Const MB_ICONQUESTION = 32
Global Const MB_ICONEXCLAMATION = 48
Global Const MB_ICONINFORMATION = 64
Global Const MB_DEFBUTTON01 = 0
Global Const MB_DEFBUTTON02 = 256
Global Const MB_DEFBUTTON03 = 512
Global Const MB_APPLMODAL = 0
Global Const MB_SYSTEMMODAL = 4096
'
' MsgBox return values
'
Global Const IDOK = 1
Global Const IDCANCEL = 2
Global Const IDABORT = 3
Global Const IDRETRY = 4
Global Const IDIGNORE = 5
Global Const IDYES = 6
Global Const IDNO = 7
'
' DPLOT Constants
'
'     DPLOT file status specifiers for "Plot DPLOT File" message

Global Const DU_DPLOT_FILE_KEEP = 0&
Global Const DU_DPLOT_FILE_DELETE = 1&

'     Scaling codes:

Global Const DU_LINEARX_LINEARY = &H1
Global Const DU_LINEARX_LOGY = &H2
Global Const DU_LOGX_LINEARY = &H3
Global Const DU_LOGX_LOGY = &H4
Global Const DU_TRIPARTITE = &H5
Global Const DU_LINEARX_PROBABILITY = &H6
Global Const DU_GRAINSIZE_DIST = &H7
Global Const DU_POLAR = &H8
Global Const DU_BARCHART = &H9
Global Const DU_LOGX_PROBABILITY = &HA
Global Const DU_PROBX_LINEARY = &HB
Global Const DU_PROBX_LOGY = &HC
Global Const DU_PROBX_PROBY = &HD
Global Const DU_TRIANGLE = &HE

'     Unit-specific scaling codes ... combine with above values

Global Const DU_DEFAULTUNITS = &H0
Global Const DU_TRIPARTITE_IN = DU_DEFAULTUNITS
Global Const DU_TRIPARTITE_FT = &H100
Global Const DU_TRIPARTITE_MM = &H200
Global Const DU_TRIPARTITE_CM = &H300
Global Const DU_TRIPARTITE_M = &H400
Global Const DU_GRAINSIZE_MM = DU_DEFAULTUNITS
Global Const DU_GRAINSIZE_IN = &H100
Global Const DU_POLAR_RADIANS = DU_DEFAULTUNITS
Global Const DU_POLAR_DEGREES = &H100
Global Const DU_USERDEFINEDUNITS = &H7F00

'     Line and symbol style codes:

Global Const DU_NONE = 0
Global Const DU_LINE_SOLID = 1
Global Const DU_LINE_LONGDASH = 2
Global Const DU_LINE_DOTTED = 3
Global Const DU_LINE_DASHDOT = 4
Global Const DU_LINE_MEDDASH = 5
Global Const DU_LINE_DASHDOTDOT = 6

Global Const DU_SYMBOL_DOT = 1
Global Const DU_SYMBOL_CROSS = 2
Global Const DU_SYMBOL_STAR = 3
Global Const DU_SYMBOL_X = 4
Global Const DU_SYMBOL_SQUARE = 5
Global Const DU_SYMBOL_DIAMOND = 6
Global Const DU_SYMBOL_TRIANGLE = 7
Global Const DU_SYMBOL_OCTAGON = 8
Global Const DU_SYMBOL_FILL_SQUARE = 9
Global Const DU_SYMBOL_FILL_DIAMOND = 10
Global Const DU_SYMBOL_FILL_TRIANGLE = 11
Global Const DU_SYMBOL_FILL_OCTAGON = 12

'     DPLOT File Types:

Global Const DU_FTYPE_DPLOT = 1
Global Const DU_FTYPE_XANDY = 2
Global Const DU_FTYPE_CONSTANTDX = 3
Global Const DU_FTYPE_MULTIPLEY = 4
Global Const DU_FTYPE_UNFORMATTED = 5
Global Const DU_FTYPE_BENDIX = 6
Global Const DU_FTYPE_WESOLD = 7
Global Const DU_FTYPE_WESNEW = 8
Global Const DU_FTYPE_NICOLETTIME = 9
Global Const DU_FTYPE_HDAS = 10

Sub StartDPLOT(FormName As Form, Junior As Integer)
    Dim cx As Integer       'Window width
    Dim cy As Integer       'Window height
    Dim hDPLOT As Long      'Handle of DPLOT window
    Dim l As Integer        'String length
    Dim ret As Integer      'API return code
    Dim x As Integer        'Window left coord
    Dim y As Integer        'Window top coord
    Dim hKey As Long        'Registration Database key
    Dim Result As Long      'API return code
    Dim Size As Long        'Length of string for filename
    Dim lpszProgram As String
                            'd:\path\filename for DPLOT.EXE
    Dim Name As String
    Dim lprc As RECT        'Window rectangle

'
'   Check to see if DPLOT is already running using the class name ("DPLOT").
'   Don't use DPLOT's window caption in the search, since the caption changes
'   dependent on whether a DPLOT document is maximized or not.
'
    Name = "DPLOT"
    If Junior <> 0 Then
        Name = Name + "JR"
    End If
    
    hDPLOT = FindWindow(Name, 0&)
    If hDPLOT = 0 Then
'
'       DPLOT is not currently running... attempt to
'       find path of DPLOT.EXE from registration database.
'
        Result = RegOpenKey(HKEY_CURRENT_USER, "Software\" + Name + "\shell\open\command", hKey)
        If Result = 0 Then
            lpszProgram = Space$(128)
            Size = Len(lpszProgram)
            Result = RegQueryValue(hKey, 0&, lpszProgram, Size)
            If Result <> 0 Then
'
'               This should never happen... There is a key in the
'               registration database for the path to DPLOT.EXE, but
'               it has no associated value.
'
                lpszProgram = Name + ".EXE"
                Size = Len(lpszProgram)
            End If
            Result = RegCloseKey(hKey)
        Else
'
'           There was no entry in the registration database. This could be the
'           result of 1) DPLOT was installed improperly or not at all,
'           or 2) registration database has been corrupted or erased. Try
'           launching DPLOT using the filename only... This will fail
'           unless the DPLOT directory is in the user's path.
'
            lpszProgram = Name + ".EXE"
            Size = Len(lpszProgram)
        End If
'
'       Append /nonag commandline switch so that this demo works properly
'       with the evaluation version
'
        l = InStr(1, lpszProgram, Chr$(0))
        If (l > 0) Then
            Size = l - 1
        End If
        lpszProgram = Left(lpszProgram, Size) + " /nonag"
        Result = Shell(lpszProgram, 1)
        hDPLOT = FindWindow(Name, 0&)
        If hDPLOT = 0 Then
            MsgBox "Cannot find " + Name + ".EXE"
            GoTo Quit
        End If
'
'       The following lines place the DPLOT window so that it is entirely visible.
'       Note that we only perform this operation if DPLOT was not already running...
'       it would be bad form to move a window that the user has already placed where
'       he wants it.
'       When this application starts up, the form is placed in the upper left corner,
'       but the user may have moved it. Place DPLOT to left or to right of the form
'       (whichever side has more room), spanning the height of the screen.
'
'       One problem here is that DPlot may be set to always maximize itself at
'       startup (Options>General menu). If this flag is set, the following will
'       not work properly. The problem is that DPlot will maximize itself (or not)
'       AFTER the following MoveWindow command is sent. About the only way around
'       this is to modify dplot.ini (or dplotjr.ini) before launching the program,
'       and changing the "Maximized" entry in the [Flags] section to 0.
'
        ret = GetWindowRect(FormName.hwnd, lprc)
        cx = (Screen.Width / Screen.TwipsPerPixelX) - lprc.Right
        If cx > lprc.Left Then
            x = lprc.Right
        Else
            x = 0
            cx = lprc.Left
        End If
        y = 0
        cy = (Screen.Height / Screen.TwipsPerPixelY)
        ret = MoveWindow(hDPLOT, x, y, cx, cy, 1)
    End If
    Result = BringWindowToTop(hDPLOT)

Quit:
End Sub

